<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>QuorumPeerMain.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">QuorumPeerMain.java</span></div><h1>QuorumPeerMain.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.zookeeper.server.quorum;

import java.io.File;
import java.io.IOException;

import javax.management.JMException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.jmx.ManagedUtil;
import org.apache.zookeeper.server.ServerCnxnFactory;
import org.apache.zookeeper.server.ZKDatabase;
import org.apache.zookeeper.server.DatadirCleanupManager;
import org.apache.zookeeper.server.ZooKeeperServerMain;
import org.apache.zookeeper.server.persistence.FileTxnSnapLog;
import org.apache.zookeeper.server.quorum.QuorumPeerConfig.ConfigException;

/**
 *
 * &lt;h2&gt;Configuration file&lt;/h2&gt;
 *
 * When the main() method of this class is used to start the program, the first
 * argument is used as a path to the config file, which will be used to obtain
 * configuration information. This file is a Properties file, so keys and
 * values are separated by equals (=) and the key/value pairs are separated
 * by new lines. The following is a general summary of keys used in the
 * configuration file. For full details on this see the documentation in
 * docs/index.html
 * &lt;ol&gt;
 * &lt;li&gt;dataDir - The directory where the ZooKeeper data is stored.&lt;/li&gt;
 * &lt;li&gt;dataLogDir - The directory where the ZooKeeper transaction log is stored.&lt;/li&gt;
 * &lt;li&gt;clientPort - The port used to communicate with clients.&lt;/li&gt;
 * &lt;li&gt;tickTime - The duration of a tick in milliseconds. This is the basic
 * unit of time in ZooKeeper.&lt;/li&gt;
 * &lt;li&gt;initLimit - The maximum number of ticks that a follower will wait to
 * initially synchronize with a leader.&lt;/li&gt;
 * &lt;li&gt;syncLimit - The maximum number of ticks that a follower will wait for a
 * message (including heartbeats) from the leader.&lt;/li&gt;
 * &lt;li&gt;server.&lt;i&gt;id&lt;/i&gt; - This is the host:port[:port] that the server with the
 * given id will use for the quorum protocol.&lt;/li&gt;
 * &lt;/ol&gt;
 * In addition to the config file. There is a file in the data directory called
 * &quot;myid&quot; that contains the server id as an ASCII decimal value.
 *
 */
<span class="fc" id="L63">public class QuorumPeerMain {</span>
<span class="fc" id="L64">    private static final Logger LOG = LoggerFactory.getLogger(QuorumPeerMain.class);</span>

    private static final String USAGE = &quot;Usage: QuorumPeerMain configfile&quot;;

    protected QuorumPeer quorumPeer;

    /**
     * To start the replicated server specify the configuration file name on
     * the command line.
     * @param args path to the configfile
     */
    public static void main(String[] args) {
<span class="nc" id="L76">        QuorumPeerMain main = new QuorumPeerMain();</span>
        try {
<span class="nc" id="L78">            main.initializeAndRun(args);</span>
<span class="nc" id="L79">        } catch (IllegalArgumentException e) {</span>
<span class="nc" id="L80">            LOG.error(&quot;Invalid arguments, exiting abnormally&quot;, e);</span>
<span class="nc" id="L81">            LOG.info(USAGE);</span>
<span class="nc" id="L82">            System.err.println(USAGE);</span>
<span class="nc" id="L83">            System.exit(2);</span>
<span class="nc" id="L84">        } catch (ConfigException e) {</span>
<span class="nc" id="L85">            LOG.error(&quot;Invalid config, exiting abnormally&quot;, e);</span>
<span class="nc" id="L86">            System.err.println(&quot;Invalid config, exiting abnormally&quot;);</span>
<span class="nc" id="L87">            System.exit(2);</span>
<span class="nc" id="L88">        } catch (Exception e) {</span>
<span class="nc" id="L89">            LOG.error(&quot;Unexpected exception, exiting abnormally&quot;, e);</span>
<span class="nc" id="L90">            System.exit(1);</span>
<span class="nc" id="L91">        }</span>
<span class="nc" id="L92">        LOG.info(&quot;Exiting normally&quot;);</span>
<span class="nc" id="L93">        System.exit(0);</span>
<span class="nc" id="L94">    }</span>

    protected void initializeAndRun(String[] args)
        throws ConfigException, IOException
    {
<span class="fc" id="L99">        QuorumPeerConfig config = new QuorumPeerConfig();</span>
<span class="pc bpc" id="L100" title="1 of 2 branches missed.">        if (args.length == 1) {</span>
<span class="fc" id="L101">            config.parse(args[0]);</span>
        }

        // Start and schedule the the purge task
<span class="fc" id="L105">        DatadirCleanupManager purgeMgr = new DatadirCleanupManager(config</span>
<span class="fc" id="L106">                .getDataDir(), config.getDataLogDir(), config</span>
<span class="fc" id="L107">                .getSnapRetainCount(), config.getPurgeInterval());</span>
<span class="fc" id="L108">        purgeMgr.start();</span>

<span class="pc bpc" id="L110" title="1 of 4 branches missed.">        if (args.length == 1 &amp;&amp; config.servers.size() &gt; 0) {</span>
<span class="fc" id="L111">            runFromConfig(config);</span>
        } else {
<span class="fc" id="L113">            LOG.warn(&quot;Either no config or no quorum defined in config, running &quot;</span>
                    + &quot; in standalone mode&quot;);
            // there is only server in the quorum -- run as standalone
<span class="nc" id="L116">            ZooKeeperServerMain.main(args);</span>
        }
<span class="fc" id="L118">    }</span>

    public void runFromConfig(QuorumPeerConfig config) throws IOException {
      try {
<span class="fc" id="L122">          ManagedUtil.registerLog4jMBeans();</span>
<span class="fc" id="L123">      } catch (JMException e) {</span>
<span class="fc" id="L124">          LOG.warn(&quot;Unable to register log4j JMX control&quot;, e);</span>
<span class="fc" id="L125">      }</span>
  
<span class="fc" id="L127">      LOG.info(&quot;Starting quorum peer&quot;);</span>
      try {
<span class="fc" id="L129">          ServerCnxnFactory cnxnFactory = ServerCnxnFactory.createFactory();</span>
<span class="fc" id="L130">          cnxnFactory.configure(config.getClientPortAddress(),</span>
<span class="fc" id="L131">                                config.getMaxClientCnxns());</span>
  
<span class="fc" id="L133">          quorumPeer = new QuorumPeer();</span>
<span class="fc" id="L134">          quorumPeer.setClientPortAddress(config.getClientPortAddress());</span>
<span class="fc" id="L135">          quorumPeer.setTxnFactory(new FileTxnSnapLog(</span>
<span class="fc" id="L136">                      new File(config.getDataLogDir()),</span>
<span class="fc" id="L137">                      new File(config.getDataDir())));</span>
<span class="fc" id="L138">          quorumPeer.setQuorumPeers(config.getServers());</span>
<span class="fc" id="L139">          quorumPeer.setElectionType(config.getElectionAlg());</span>
<span class="fc" id="L140">          quorumPeer.setMyid(config.getServerId());</span>
<span class="fc" id="L141">          quorumPeer.setTickTime(config.getTickTime());</span>
<span class="fc" id="L142">          quorumPeer.setMinSessionTimeout(config.getMinSessionTimeout());</span>
<span class="fc" id="L143">          quorumPeer.setMaxSessionTimeout(config.getMaxSessionTimeout());</span>
<span class="fc" id="L144">          quorumPeer.setInitLimit(config.getInitLimit());</span>
<span class="fc" id="L145">          quorumPeer.setSyncLimit(config.getSyncLimit());</span>
<span class="fc" id="L146">          quorumPeer.setQuorumVerifier(config.getQuorumVerifier());</span>
<span class="fc" id="L147">          quorumPeer.setCnxnFactory(cnxnFactory);</span>
<span class="fc" id="L148">          quorumPeer.setZKDatabase(new ZKDatabase(quorumPeer.getTxnFactory()));</span>
<span class="fc" id="L149">          quorumPeer.setLearnerType(config.getPeerType());</span>
<span class="fc" id="L150">          quorumPeer.setSyncEnabled(config.getSyncEnabled());</span>
<span class="fc" id="L151">          quorumPeer.setQuorumListenOnAllIPs(config.getQuorumListenOnAllIPs());</span>
  
<span class="fc" id="L153">          quorumPeer.start();</span>
<span class="fc" id="L154">          quorumPeer.join();</span>
<span class="nc" id="L155">      } catch (InterruptedException e) {</span>
          // warn, but generally this is ok
<span class="nc" id="L157">          LOG.warn(&quot;Quorum Peer interrupted&quot;, e);</span>
<span class="fc" id="L158">      }</span>
<span class="fc" id="L159">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>